<?php
/**
 * Roof Water Proofing functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package roof_water_proofing
 */

$roof_water_proofing_theme_data = wp_get_theme();
if( ! defined( 'ROOF_WATER_PROOFING_THEME_VERSION' ) ) define ( 'ROOF_WATER_PROOFING_THEME_VERSION', $roof_water_proofing_theme_data->get( 'Version' ) );
if( ! defined( 'ROOF_WATER_PROOFING_THEME_NAME' ) ) define( 'ROOF_WATER_PROOFING_THEME_NAME', $roof_water_proofing_theme_data->get( 'Name' ) );
if( ! defined( 'ROOF_WATER_PROOFING_THEME_TEXTDOMAIN' ) ) define( 'ROOF_WATER_PROOFING_THEME_TEXTDOMAIN', $roof_water_proofing_theme_data->get( 'TextDomain' ) );

if ( ! defined( 'ROOF_WATER_PROOFING_VERSION' ) ) {
	define( 'ROOF_WATER_PROOFING_VERSION', '1.0.0' );
}

if ( ! function_exists( 'roof_water_proofing_setup' ) ) :
	
	function roof_water_proofing_setup() {
		
		load_theme_textdomain( 'roof-water-proofing', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'roof-water-proofing' ),
				'social'  => esc_html__( 'Social', 'roof-water-proofing' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'roof_water_proofing_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );
	}
endif;
add_action( 'after_setup_theme', 'roof_water_proofing_setup' );

function roof_water_proofing_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'roof_water_proofing_content_width', 640 );
}
add_action( 'after_setup_theme', 'roof_water_proofing_content_width', 0 );

function roof_water_proofing_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'roof-water-proofing' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'roof-water-proofing' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	$roof_water_proofing_footer_widget_column = get_theme_mod('roof_water_proofing_footer_widget_column','4');
	for ($roof_water_proofing_i=1; $roof_water_proofing_i<=$roof_water_proofing_footer_widget_column; $roof_water_proofing_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'roof-water-proofing' )  . $roof_water_proofing_i,
			'id' => 'roof-water-proofing-footer-widget-' . $roof_water_proofing_i,
			'description' => __( 'The Footer Widget Area', 'roof-water-proofing' )  . $roof_water_proofing_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'roof_water_proofing_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function roof_water_proofing_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Slick style.
	wp_enqueue_style( 'slick-style', get_template_directory_uri() . '/resource/css/slick' . $min . '.css', array(), '1.8.1' );

	// Owl Carousel style.
	wp_enqueue_style( 'owl-carousel-css', get_template_directory_uri() . '/resource/css/owl.carousel' . '.css', array(), '2.3.4' );

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'roof-water-proofing-style', get_template_directory_uri() . '/style.css', array(), ROOF_WATER_PROOFING_VERSION );

	// RTL style.
	wp_style_add_data('roof-water-proofing-style', 'rtl', 'replace');
	
	if (get_theme_mod('roof_water_proofing_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	// Navigation script.
	wp_enqueue_script( 'roof-water-proofing-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), ROOF_WATER_PROOFING_VERSION, true );

	// Owl Carousel.
	wp_enqueue_script( 'owl-carouselscript', get_template_directory_uri() . '/resource/js/owl.carousel' . '.js', array( 'jquery' ), '2.3.4', true );

	// Slick script.
	wp_enqueue_script( 'slick-script', get_template_directory_uri() . '/resource/js/slick' . $min . '.js', array( 'jquery' ), '1.8.1', true );

	// Custom script.
	wp_enqueue_script( 'roof-water-proofing-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery' ), ROOF_WATER_PROOFING_VERSION, true );


	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );
}
add_action( 'wp_enqueue_scripts', 'roof_water_proofing_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'roof_water_proofing_products_per_page' );
function roof_water_proofing_products_per_page( $cols ) {
  	return  get_theme_mod( 'roof_water_proofing_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'roof_water_proofing_loop_columns');
	if (!function_exists('roof_water_proofing_loop_columns')) {
	function roof_water_proofing_loop_columns() {
		return get_theme_mod( 'roof_water_proofing_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function roof_water_proofing_links_setup() {
	if ( ! defined( 'ROOF_WATER_PROOFING_PREMIUM_PAGE' ) ) {
	define('ROOF_WATER_PROOFING_PREMIUM_PAGE',__('https://asterthemes.com/products/water-proofing-wordpress-theme','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_THEME_PAGE' ) ) {
		define('ROOF_WATER_PROOFING_THEME_PAGE',__('https://asterthemes.com/products/roof-water-proofing','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_SUPPORT' ) ) {
	define('ROOF_WATER_PROOFING_SUPPORT',__('https://wordpress.org/support/theme/roof-water-proofing/','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_REVIEW' ) ) {
	define('ROOF_WATER_PROOFING_REVIEW',__('https://wordpress.org/support/theme/roof-water-proofing/reviews/','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_PRO_DEMO' ) ) {
	define('ROOF_WATER_PROOFING_PRO_DEMO',__('https://demo.asterthemes.com/roof-water-proofing/','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_THEME_DOCUMENTATION' ) ) {
	define('ROOF_WATER_PROOFING_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/roof-water-proofing-free/','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_PREMIUM_DOCUMENTATION' ) ) {
	define('ROOF_WATER_PROOFING_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/roof-water-proofing-pro/','roof-water-proofing'));
	}
	if ( ! defined( 'ROOF_WATER_PROOFING_BUNDLE_PAGE' ) ) {
		define('ROOF_WATER_PROOFING_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','roof-water-proofing'));
	}
}
add_action('after_setup_theme', 'roof_water_proofing_links_setup');

/**
 * Theme Wizard
*/
add_action( 'init', 'roof_water_proofing_load_theme_wizard' );
function roof_water_proofing_load_theme_wizard() {
    require get_parent_theme_file_path( '/theme-wizard/config.php' );
}

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

// Enqueue Customizer live preview script
function roof_water_proofing_customizer_live_preview() {
    wp_enqueue_script(
        'roof-water-proofing-customizer',
        get_template_directory_uri() . '/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'roof_water_proofing_customizer_live_preview');

// Featured Image Dimension
function roof_water_proofing_blog_post_featured_image_dimension(){
	if(get_theme_mod('roof_water_proofing_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}


// Reset all theme settings
function roof_water_proofing_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('roof_water_proofing_top_header_phone_number');
		remove_theme_mod('roof_water_proofing_top_header_email_id');
		remove_theme_mod('roof_water_proofing_header_button_label_');
		remove_theme_mod('roof_water_proofing_header_button_link_');
		remove_theme_mod('roof_water_proofing_trending_post_category');
		remove_theme_mod('roof_water_proofing_services_short_heading');
		remove_theme_mod('roof_water_proofing_services_heading');
		remove_theme_mod('roof_water_proofing_services_content');
		remove_theme_mod('roof_water_proofing_banner_button_label_');
		remove_theme_mod('roof_water_proofing_enable_topbar');
		remove_theme_mod('roof_water_proofing_enable_service_section');

        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'roof-water-proofing')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'roof-water-proofing')));
    }
}
add_action('wp_ajax_roof_water_proofing_reset_demo_import_settings', 'roof_water_proofing_reset_demo_import_settings'); 